package earth.krakatao;

import earth.krakatao.protocol.KraSocketClientProtocolMessage;
import java.util.TimerTask;

public class KraSocketClientMessageTimerTask extends TimerTask {

  private final SocketClient socketClient;

  public KraSocketClientMessageTimerTask(SocketClient socketClient) {
    this.socketClient = socketClient;
  }

  @Override
  public void run() {
    KraSocketClient.getLogger().info(
        "MessageTimerTask is running. SendQueueMessages size: " + this.socketClient.getKraProtocol()
            .getSendQueueMessages()
            .size());
    long currentTimeMillis = System.currentTimeMillis();

    for (KraSocketClientProtocolMessage msg : this.socketClient.getKraProtocol()
        .getSendQueueMessages()
        .values()) {
      if ((currentTimeMillis - msg.getTime())
          > this.socketClient.getWebSocketAckTimeouts()
          .get(msg.getTrySendCount())) {
        KraSocketClient.getLogger().info("MessageTimerTask here");

        msg.setTime(currentTimeMillis);

        this.socketClient.SendMessage(msg);

        if (msg.getTrySendCount() < 4) {
          msg.setTrySendCount(msg.getTrySendCount() + 1);
        }
      }
    }
  }
}
