package earth.krakatao.events;

import earth.krakatao.protocol.KraSocketClientProtocolMessage;
import java.util.ArrayList;
import java.util.List;
import org.java_websocket.handshake.ServerHandshake;

public class KraSocketClientEventInitiater {

  private final List<KraSocketClientEventInterface> listenerList = new ArrayList<>();

  public void addListener(KraSocketClientEventInterface testListener) {
    listenerList.add(testListener);
  }

  public void callOnOpen(ServerHandshake serverHandshake) {
    for (KraSocketClientEventInterface eventInterfaceListener : listenerList) {
      eventInterfaceListener.onOpen(serverHandshake);
    }
  }

  public void callOnMessage(KraSocketClientProtocolMessage kraProtocolMessage) {
    for (KraSocketClientEventInterface eventInterfaceListener : listenerList) {
      eventInterfaceListener.onMessage(kraProtocolMessage);
    }
  }

  public void callOnClose(int code, String reason, boolean remote) {
    for (KraSocketClientEventInterface eventInterfaceListener : listenerList) {
      eventInterfaceListener.onClose(code, reason, remote);
    }
  }
}
